var unirest = require('unirest');
var CryptoJS = require('crypto-js');

var FusionUrl = process.env.FusionUrl;
var DahuaHost = process.env.DahuaHost;
var DahuaUser = process.env.DahuaUser;
var DahuaPass = process.env.DahuaPass;
var RstpHost = process.env.RstpHost;
var CategoriaCameraId = process.env.CategoriaCameraId;

// Postgres
const pg = require('pg');

exports.getMapUrl = (req, res, next) => {

  var req = unirest('POST', FusionUrl + '/logoutAll')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "username": process.env.MapFusionUserName,
        "password": process.env.MapFusionPassword
    }))
    .end(function (cres) { 
        if (cres.error) {
          console.log(cres.error);
          return;
        }
          console.log(cres.raw_body);
    
    req = unirest('POST', FusionUrl + '/login/')
    .strictSSL(false)
    .headers({
          'User-Agent': 'CodeJava Agent',
          'Accept': 'application/json',
          'Content-Type': 'application/x-www-form-urlencoded'
      })
      .send('username=' + process.env.MapFusionUserName)
      .send('password=' + process.env.MapFusionPassword)
      .send('dominio=undefined')
      .end(function (cres) { 
          if (cres.error) {
            console.log(cres.error);
            return;
          }
          console.log(cres.raw_body);
          res.redirect(302, FusionUrl + "/#/Mapa?token=" + JSON.stringify(cres.body));
      });
    
    });
};

exports.getFusionUrl = (req, res, next) => {

  var req = unirest('POST', FusionUrl + '/logoutAll')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "username": process.env.AdminFusionUserName,
        "password": process.env.AdminFusionPassword
    }))
    .end(function (cres) { 
        if (cres.error) 
	    console.log(cres.error); 
          
	console.log(cres.raw_body);
    
    req = unirest('POST', FusionUrl + '/login/')
    .strictSSL(false)
    .headers({
          'User-Agent': 'CodeJava Agent',
          'Accept': 'application/json',
          'Content-Type': 'application/x-www-form-urlencoded'
      })
      .send('username=' + process.env.AdminFusionUserName)
      .send('password=' + process.env.AdminFusionPassword)
      .send('dominio=undefined')
      .end(function (cres) { 
          if (cres.error) {
        console.log(cres.error);
        return;
      }
          console.log(cres.raw_body);
      res.redirect(302,  FusionUrl + "/#/?token=" + JSON.stringify(cres.body));
      });
    
    });
};

exports.getFusionUrlById = (req, res, next) => {
  let loginId = req.params.id;
  var user = process.env.ScreenUserName.replace("X", loginId);

  console.log("User: " + user);
  console.log("Pass: " + process.env.ScreenPassword);
  var req = unirest('POST', FusionUrl + '/logoutAll')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "username": user,
        "password": process.env.ScreenPassword
    }))
    .end(function (cres) { 
        if (cres.error) 
	    console.log(cres.error); 
          
	console.log(cres.raw_body);
    
    req = unirest('POST', FusionUrl + '/login/')
    .strictSSL(false)
    .headers({
          'User-Agent': 'CodeJava Agent',
          'Accept': 'application/json',
          'Content-Type': 'application/x-www-form-urlencoded'
      })
      .send('username=' + user)
      .send('password=' + process.env.ScreenPassword)
      .send('dominio=undefined')
      .end(function (cres) { 
          if (cres.error) {
        console.log(cres.error);
        return;
      }
          console.log(cres.raw_body);
      res.redirect(302,  FusionUrl + "/#/?token=" + JSON.stringify(cres.body));
      });
    
    });
};

exports.getScrollerUrlById = (req, res, next) => {
  let loginId = req.params.id;
  var user = process.env.ScrollerUserName.replace("X", loginId);

  console.log("User: " + user);
  console.log("Pass: " + process.env.ScrollerPassword);
  var req = unirest('POST', FusionUrl + '/logoutAll')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "username": user,
        "password": process.env.ScrollerPassword
    }))
    .end(function (cres) { 
        if (cres.error) 
      console.log(cres.error); 
          
  console.log(cres.raw_body);
    
    req = unirest('POST', FusionUrl + '/login/')
    .strictSSL(false)
    .headers({
          'User-Agent': 'CodeJava Agent',
          'Accept': 'application/json',
          'Content-Type': 'application/x-www-form-urlencoded'
      })
      .send('username=' + user)
      .send('password=' + process.env.ScrollerPassword)
      .send('dominio=undefined')
      .end(function (cres) { 
          if (cres.error) {
        console.log(cres.error);
        return;
      }
      console.log(cres.raw_body);
      
      res.redirect(302,  FusionUrl + "/#/show_scroller?token=" + JSON.stringify(cres.body));
      });
    
    });
};

exports.getById = (req, res, next, retryRequest = false) => {
  let videoId = req.params.id;
  res.setHeader('Access-Control-Allow-Origin', '*');
      res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE'); // If needed
      res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,content-type'); // If needed
      res.setHeader('Access-Control-Allow-Credentials', true); // If needed
  
  var cbSecondAuth = function (cres) {
    if (typeof cres.body.error !== 'undefined')
      res.status(401).send('Error ' + cres.body.error);
    else {
      sendStartVideo(function (video) {
        if (video.body.code != 1000) 
          if (retryRequest) {
            res.status(401).send("ID da camera inválido");
          } else {
            exports.getById(req, res, next, true);
          }
        else {
          console.log("video:", video.body);
          res.status(200).send(video.body.data.url + "&token=" + video.body.data.token);
      //    res.redirect(302, "http://10.1.1.51:8088/?" + video.body.data.url + '&token=' + video.body.data.token);
        }
      }, cres.body, videoId, retryRequest);
    }
  };

  sendFirstAuth(function (cres) { 
    if (typeof cres.body !== 'undefined') {
      if (typeof cres.body.randomKey === 'undefined')
        res.status(401).send('Error ' + cres.body.error);
      else {
        console.log("Calling second: ", cres.body);
        sendSecondAuth(cbSecondAuth, cres.body, retryRequest);
      }
    } else {
      console.log("Cres.body undefined");
    }
  }, retryRequest);

};

exports.getLinkById = (req, res, next, retryRequest = false) => {
  let videoId = req.params.id;
  res.setHeader('Access-Control-Allow-Origin', '*');
      res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE'); // If needed
      res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,content-type'); // If needed
      res.setHeader('Access-Control-Allow-Credentials', true); // If needed
  
  var cbSecondAuth = function (cres) { 
    if (typeof cres.body.error !== 'undefined')
      res.status(401).send('Error ' + cres.body.error);
    else {
      sendStartVideo(function (video) {
        if (video.body.code != 1000) 
          if (retryRequest) {
            res.status(401).send("ID da camera inválido");
          } else {
            exports.getLinkById(req, res, next, true);
          }
        else {
          console.log("video:", video.body);
          //res.status(200).send(video.body.data.url + "&token=" + video.body.data.token);
          res.redirect(302, FusionUrl + "/ws_rtsp_proxy/?" + video.body.data.url + '&token=' + video.body.data.token);
        }
      }, cres.body, videoId, retryRequest);
    }
  };

  sendFirstAuth(function (cres) {
    if (typeof cres.body !== 'undefined') {
      if (typeof cres.body.randomKey === 'undefined')
        res.status(401).send('Error ' + cres.body.error);
      else {
        console.log("Calling second: ", cres.body);
        sendSecondAuth(cbSecondAuth, cres.body, retryRequest);
      }
    } else {
      console.log("Cres.body undefined");
    }
  }, retryRequest);

};

function sendFirstAuth(cbFirstAuth, secondCall = false) {
  console.log("---> SendFirst Auth");
  let host = DahuaHost;
  let user = DahuaUser;
  if (secondCall) {
    host = process.env.DahuaHostCispbaf;
    user = process.env.DahuaUserCispbaf;
  }
  var req = unirest('GET', host + '/brms/api/v1.0/accounts/authorize')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "userName": user,
        "ipAddress": "",
        "clientType": "WINPC_V2"
    }))

    .end(function (res) { cbFirstAuth(res) });
}

function sendSecondAuth(cbSecondAuth, data, secondCall = false) {

  let host = DahuaHost;
  let user = DahuaUser;
  if (secondCall) {
    host = process.env.DahuaHostCispbaf;
    user = process.env.DahuaUserCispbaf;
  }

  let temp1 = CryptoJS.MD5(DahuaPass).toString();
  let temp2 = CryptoJS.MD5(user + temp1).toString();
  let temp3 = CryptoJS.MD5(temp2).toString();
  let temp4 = CryptoJS.MD5(user + ":" + data.realm + ":" + temp3).toString();
  let signature = CryptoJS.MD5(temp4 + ":" + data.randomKey).toString();


  var req = unirest('POST', host + '/brms/api/v1.0/accounts/authorize')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "mac": "7C:8A:E1:D9:BD:85",
        "signature": signature,
        "userName": user,
        "randomKey": data.randomKey,
        "publicKey": data.publicKey,
        "encryptType": "MD5",
        "ipAddress": "192.168.3.29",
        "clientType": "WINPC_V2",
        "userType": "0"
    }))
    .end(function (res) {  cbSecondAuth(res) });

}

function sendStartVideo(cbSendVideo, data, videoId, retryRequest = false) {

  let host = DahuaHost;
  if (retryRequest) {
    host = process.env.DahuaHostCispbaf;
  }

  var req = unirest('POST', host + '/brms/api/v1.0/MTS/Video/StartVideo')
  .strictSSL(false)
    .headers({
        'X-Subject-Token': data.token,
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "clientType": "WINPC_V2",
        "clientMac": "7C:8A:E1:D9:BD:85",
        "clientPushId": "",
        "project": "COMTEX",
        "method": "MTS.Video.StartVideo",
        "data": {
            "streamType": "1",
            "optional": "/brms/api/v1.0/MTS/Video/StartVideo",
            "trackId": "",
            "extend": "",
            "channelId": videoId + "$1$0$0",
            "keyCode": "",
            "planId": "",
            "dataType": "2",
            "enableRtsps": "0"
        }
    }))
    .end(function (res) {
    /* Get only the first one */
    if (typeof res.body.data != 'undefined' && res.body.data) {
                  var vdahuaURL = res.body.data.url.split('|');
                  if (vdahuaURL.length > 1)
                    res.body.data.url = vdahuaURL[0];
    }
    cbSendVideo(res);
    });

}

exports.getByControl = (req, res) => {
  let videoId = req.params.key;
  let controlId = req.params.id;
  console.log(controlId);
  console.log("video", videoId);
  var cbSecondAuth = function (cres) {
    if (typeof cres.body.error !== 'undefined')
      res.status(401).send('Error ' + cres.body.error);
    else if (controlId == 'increase' || controlId == 'decrease'){
      let lenId;
      if(controlId =='increase') {
         lenId = "1";
      } else if (controlId == 'decrease') {
        lenId = "2";
      }
      let urlZoom = sendCamControlZoom(function (play) {

        if (play.body.code != 1000) {
          res.status(401).send("Erro ao executar o Zoom.");
        } else {
          res.status(200).send(play.body.desc);
        }
      }, cres.body, req.params.id, req.params.key);
      //sendCamControlZoom(cres.body, videoId, lenId);
    } else {
      let urlControl = sendCamControl(function (play) {

        if (play.body.code != 1000) {
          res.status(401).send("Erro ao executar o Controle.");
        } else {
          res.status(200).send(play.body.desc);
        }
      }, cres.body, req.params.id, req.params.key);
      //sendCamControl(cres.body, videoId, controlId);
    }
    };

    sendFirstAuth(function (cres) {
      if (typeof cres.body !== 'undefined') {
        if (typeof cres.body.randomKey === 'undefined')
          res.status(401).send('Error ' + cres.body.error);
        else {
          console.log("Calling second: ", cres.body);
          sendSecondAuth(cbSecondAuth, cres.body);
        }
      } else {
        console.log("Cres.body undefined");
      }
    });

  function sendCamControl(cbSendCamControl, data, key, id) {
    console.log("FUNCTION CONTROL");
    console.log("ID CONTROL:", key);
    console.log("ID CAM:", id);
    var req = unirest('POST', DahuaHost + '/brms/api/v1.0/DMS/Ptz/OperateDirect')
    .strictSSL(false)
      .headers({
          'X-Subject-Token': data.token,
          'Content-Type': 'application/json'
      })
      .send(JSON.stringify({
          "clientType": "WINPC_V2",
          "clientMac": "7C:8A:E1:D9:BD:85",
          "clientPushId": "",
          "project": "COMTEX",
          "method": "MTS.Ptz.OperateDirect",
          "data": {
              "optional": "/brms/api/v1.0/DMS/Ptz/OperateDirect",
              "stepY": "4",
              "extend": "",
              "direct": key,
              "channelId": id + "$1$0$0",
              "stepX": "4",
              "command": "1",
          }
      }))
      .end(function (res) {
        console.log("rerersre", res.body);
        if (res.body.code != 1000) {
          console.log("Erro ao executar o Controle: "+ res.body.desc);
          cbSendCamControl(res);
        } 
        else {
          cbSendCamControl(res);
        }
      });
  
  }

  function sendCamControlZoom(cbSendCamControlZoom ,data, key, id) {
    console.log("FUNCTION ZOOM");
    if(key =='increase') {
      key = "1";
    } else if (key == 'decrease') {
      key = "2";
    }

    console.log("ID CAM:", key);
    console.log("ID ZOOM:", id);
    var req = unirest('POST', DahuaHost + '/brms/api/v1.0/DMS/Ptz/OperateCamera')
    .strictSSL(false)
      .headers({
          'X-Subject-Token': data.token,
          'Content-Type': 'application/json'
      })
      .send(JSON.stringify({
          "clientType": "WINPC_V2",
          "clientMac": "7C:8A:E1:D9:BD:85",
          "clientPushId": "",
          "project": "COMTEX",
          "method": "MTS.Ptz.OperateCamera",
          "data": {
              "optional": "/brms/api/v1.0/DMS/Ptz/OperateCamera",
              "extend": "",
              "direct": key,
              "command": "1",
              "channelId": id + "$1$0$0",
              "step": "1",
              "operateType": "1",
          }
      }))
      .end(function (res) {
      /* Get only the first one */
      if (res.body.code != 1000) {
        console.log("Erro ao executar o Zoom: "+ res.body.desc);
        cbSendCamControlZoom(res);
      } 
      else {
        cbSendCamControlZoom(res);
      }
      });
  
  }
}

exports.getStopControl = (req, res) => {
  let videoId = req.params.key;
  let controlId = req.params.id;
  console.log(controlId);
  console.log("video", videoId);
  var cbSecondAuth = function (cres) {
    if (typeof cres.body.error !== 'undefined')
      res.status(401).send('Error ' + cres.body.error);
    else{
      let urlStop = sendCamStopControl(function (play) {
        if (play.body.code != 1000) {
          res.status(401).send("Erro ao executar a Pausa.");
        } else {
          res.status(200).send(play.body.desc);
        }
      }, cres.body, req.params.id, req.params.key);
    }
    };

    sendFirstAuth(function (cres) {
      console.log("cres body:", cres.body);
      if (typeof cres.body !== 'undefined') {
        if (typeof cres.body.randomKey === 'undefined')
          res.status(401).send('Error ' + cres.body.error);
        else {
          console.log("Calling second: ", cres.body);
          sendSecondAuth(cbSecondAuth, cres.body);
        }
      } else {
        console.log("Cres.body undefined");
      }
    });

  function sendCamStopControl(cbSendCamStopControl, data, key, id) {
    console.log("FUNCTION CONTROL STOP");
    console.log("ID STOP:", key);
    console.log("ID CAM:", id);
    var req = unirest('POST', DahuaHost + '/brms/api/v1.0/DMS/Ptz/OperateDirect')
    .strictSSL(false)
      .headers({
          'X-Subject-Token': data.token,
          'Content-Type': 'application/json'
      })
      .send(JSON.stringify({
          "clientType": "WINPC_V2",
          "clientMac": "7C:8A:E1:D9:BD:85",
          "clientPushId": "",
          "project": "COMTEX",
          "method": "MTS.Ptz.OperateDirect",
          "data": {
              "optional": "/brms/api/v1.0/DMS/Ptz/OperateDirect",
              "stepY": "1",
              "extend": "",
              "direct": "0",
              "channelId": id + "$1$0$0",
              "stepX": "1",
              "command": "0",
          }
      }))
      .end(function (res) {
      /* Get only the first one */
      console.log("resresres:", res.body);
      if (res.body.code != 1000) {
        console.log("Erro ao executar a Pausa: "+ res.body.desc);
        cbSendCamStopControl(res);
      } 
      else {
        cbSendCamStopControl(res);
      }

      });
  
  }
}

var timerFunc = function () {
  console.log("timerFunc Loop");
  _getDevices(false, null);
  setTimeout(timerFunc, 60000);
}

setTimeout(timerFunc, 60000);

exports.getDevices = (req, res, next) => {
  _getDevices(true, res);
  res.setHeader('Access-Control-Allow-Origin', '*');
}

function _getDevices(canAdd, res) {
  var cbSecondAuth = function (cres) {
      if (typeof cres.body.error !== 'undefined' || typeof cres.body.token === 'undefined') {
        if (res != null) {
          res.status(401).send('Error ' + cres.body.error);
        } else {
          console.log('Error ' + cres.body.error);
        }
      } else {
        sendGetDevices(function (success) {
          if (canAdd) {
              if (!success) {
                res.status(401).send(false);
              } else {
                res.status(200).send(true);
              }
          }
        },cres.body, canAdd);
      }
    };

    sendFirstAuth(function (cres) {
      if (typeof cres.body !== 'undefined') {
        if (typeof cres.body.randomKey === 'undefined')
          if (res != null) {
            res.status(401).send('Error ' + cres.body.error);
          } else {
            console.log('Error ' + cres.body.error);
          }
        else {
          console.log("Calling second: ", cres.body);
          sendSecondAuth(cbSecondAuth, cres.body);
        }
      } else {
        console.log("Cres.body undefined");
      }
    });
}

function sendGetDevices(cbGetDevices, data, canAdd) {

  var req = unirest('POST', DahuaHost + '/admin/API/tree/devices')
  .strictSSL(false)
    .headers({
        'X-Subject-Token': data.token,
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "orgCode": "",
        "deviceCodes": [],
        "categories": []
    }))
    .end(function (res) {
      let data = JSON.parse(res.body).data;
      if (typeof data != 'undefined') {
        console.log("---> Device Response: ");
        listCameras(data.devices, canAdd);
        cbGetDevices(true);
      } else {
        cbGetDevices(false);
      }
    });

}

async function listCameras(data, canAdd) {
  console.log("List Cameras");

  const cameras = new pg.Client({
    user: process.env.DB_User,
    host: process.env.DB_Host,
    database: process.env.DB_Database,
    password: process.env.DB_Password,
    port: process.env.DB_Port
  });

  await cameras.connect();

  let addNew = [];
  let addNewFace = [];
  let dontRemove = [];
  let condExtraPTZ;
  let location;
  let dataDesc = "IPC";

  for(let i = 0; i < data.length; i++) {
    let result;
    let getLocation = false;
    if (data[i]) {
      dontRemove.push(data[i].code);

      data[i].units.forEach(unit => {
        unit.channels.forEach(channel => {
          condExtraPTZ = channel.cameraType;
          if (channel.channelName) {
            channel.channelName = channel.channelName.replace(/'/g, "''");
            dataDesc = channel.channelName;
          }
          if (channel.gpsX && channel.gpsY) {
            getLocation = true;
            location = 'SRID=4326;POINT('+ channel.gpsX +' '+ channel.gpsY +')';
          }
        })
      });

      let query = `SELECT * FROM "Camera" WHERE chave_estrangeira = '${data[i].code}' and "CategoriaCameraId" = ${CategoriaCameraId}`;
      let extrasP = '{"informacoes": [{"label": "PTZ","valor": "2","tipo": ""}]}';
      result = await cameras.query(query);

      if (result.rowCount > 0) { // Code exists in database
        let queryUpdate
        let queryUpdateFace
        let queryPtz

        if(condExtraPTZ == 2) {
          queryPtz = `UPDATE "Camera" set "extras" = '${extrasP}' WHERE chave_estrangeira = '${data[i].code}'`;
        } else {
          queryPtz = `UPDATE "Camera" set "extras" = 'null' WHERE chave_estrangeira = '${data[i].code}'`;
        }
        if (data[i].status == 1) {
          if (getLocation) {
            queryUpdate = `UPDATE "Camera" set "urlIcone" = 'uploads/png/camera_azul.png', nome = '${data[i].name}', descricao = '${dataDesc}', "poiGeometrico" = '${location}' WHERE chave_estrangeira = '${data[i].code}'`;
          } else {
            queryUpdate = `UPDATE "Camera" set "urlIcone" = 'uploads/png/camera_azul.png', nome = '${data[i].name}', descricao = '${dataDesc}' WHERE chave_estrangeira = '${data[i].code}'`;
          }
          queryUpdateFace = `UPDATE "Face" set name = '${data[i].name}', endereco = 'DAHUA' WHERE chave_estrangeira = '${data[i].code}'`;
        } else {
          if (getLocation) {
            queryUpdate = `UPDATE "Camera" set "urlIcone" = 'uploads/png/camera_vermelha.png', nome = '${data[i].name}', descricao = '${dataDesc}', "poiGeometrico" = '${location}' WHERE chave_estrangeira = '${data[i].code}'`;
          } else {
            queryUpdate = `UPDATE "Camera" set "urlIcone" = 'uploads/png/camera_vermelha.png', nome = '${data[i].name}', descricao = '${dataDesc}' WHERE chave_estrangeira = '${data[i].code}'`;
          }
          queryUpdateFace = `UPDATE "Face" set name = '${data[i].name}', endereco = 'DAHUA' WHERE chave_estrangeira = '${data[i].code}'`;
        }
        await cameras.query(queryUpdate);
        await cameras.query(queryUpdateFace);
        await cameras.query(queryPtz);
      } else {
        addNew.push(data[i]);
      }

      let queryFace = `SELECT * FROM "Face" WHERE chave_estrangeira = '${data[i].code}'`;
      resultFace = await cameras.query(queryFace);
      if (resultFace.rowCount < 1) {
       addNewFace.push(data[i]); 
      }

    } else {
      console.log("Data undefined");
    }
  }

  if (canAdd) {

    var notIn = `(`;
    for(let i = 0; i < dontRemove.length; i++) {
      if (i == dontRemove.length - 1) {
        notIn = notIn + `'` + dontRemove[i] + `')`;
      } else {
        notIn = notIn + `'` + dontRemove[i] + `',`;
      }
    }
    
    // Deleta as câmeras da tabela Cameras do sistema que não existem no retorno da API
    var queryRemove = `DELETE FROM "Camera" WHERE chave_estrangeira NOT IN ${notIn} and "CategoriaCameraId" = ${CategoriaCameraId}`;
    await cameras.query(queryRemove);

    // Deleta as câmeras da tabela Face do sistema que não existem no retorno da API
    var queryRemoveFace = `DELETE FROM "Face" WHERE chave_estrangeira NOT IN ${notIn} and endereco = 'DAHUA'`;
    await cameras.query(queryRemoveFace);

    // Adiciona as câmeras da API que não existem no sistema
    if (addNew.length > 0) {
      let number;
      let queryNew;
      let condExtra;
      let dataDesc = "IPC";
      let location = "0101000020E6100000F03504C765A445C069E21DE049AF36C0";

      for(let i = 0; i < addNew.length; i++) {
        // Checando o status e definindo ícone
        let urlIcone = "uploads/png/camera_azul.png";
        if (addNew[i].status < 1) {
          urlIcone = "uploads/png/camera_vermelha.png";
        }

        // Checando o número da última câmera e incrementando mais 1 para a nova
        number = await cameras.query(`SELECT * FROM "Camera" ORDER BY numero DESC LIMIT 1`);
        number = number.rows[0].numero + 1;

        addNew[i].units.forEach(unit => {
          unit.channels.forEach(channel => {
            condExtra = channel.cameraType;
            if (channel.channelName) {
              dataDesc = channel.channelName;
            }
            if (channel.gpsX && channel.gpsY) {
              location = 'SRID=4326;POINT('+ channel.gpsX +' '+ channel.gpsY +')';
            }
          })
        });

        if(condExtra == 2) {
          //definindo extras cameras PTZ
          let extrasPTZ = '{"informacoes": [{"label": "PTZ","valor": "2","tipo": ""}]}';
  
          // Criando a query para inserir a nova câmera no banco
          queryNew = `INSERT INTO "Camera" (nome, descricao, numero, altura, largura, url, "createdAt", "updatedAt", "urlIcone", "poiGeometrico", "CategoriaCameraId", chave_estrangeira, extras) values ('${addNew[i].name}', '${dataDesc}', ${number}, 600, 800, '', '2022-09-15 16:17:01.311 -0300', '2022-09-27 16:33:31.554 -0300', '${urlIcone}', '${location}', ${CategoriaCameraId}, '${addNew[i].code}', '${extrasPTZ}')`;
          await cameras.query(queryNew);
        } else {
          // Definindo extras da camera 
          let extras = 'null';
  
          // Criando a query para inserir a nova câmera no banco
          queryNew = `INSERT INTO "Camera" (nome, descricao, numero, altura, largura, url, "createdAt", "updatedAt", "urlIcone", "poiGeometrico", "CategoriaCameraId", chave_estrangeira, extras) values ('${addNew[i].name}', '${dataDesc}', ${number}, 600, 800, '', '2022-09-15 16:17:01.311 -0300', '2022-09-27 16:33:31.554 -0300', '${urlIcone}', '${location}', ${CategoriaCameraId}, '${addNew[i].code}', '${extras}')`;
          await cameras.query(queryNew);
        }
      }
    }

    if (addNewFace.length > 0) {
      let queryNewFace = '';
      for(let i = 0; i < addNewFace.length; i++) {
        queryNewFace = `INSERT INTO "Face" ("name", "template", "createdAt", "updatedAt", endereco, tipo, "AplicacaoId", chave_estrangeira) values ('${addNewFace[i].name}', 'app/components/modulos/modulo-cameras.html', '2022-09-15 16:17:01.311 -0300', '2022-09-15 16:17:01.311 -0300', 'DAHUA', 'INSTANCIA', 2, '${addNewFace[i].code}')`;
        await cameras.query(queryNewFace);
      }
    }


  }
  await cameras.end();
  console.log("Finalizou");
}

exports.getPlayback = (req, res, next) => {

  return res.status(401).send("Erro ao executar o PlayBack.");
  var cbSecondAuth = function (cres) {
    if (typeof cres.body.error !== 'undefined')
      if (res != null) {
        res.status(401).send('Error ' + cres.body.error);
      } else {
        console.log('Error ' + cres.body.error);
      }
    else {
      let urlPlayback = sendPlayback(function (response) {

        if (typeof response == "number") {
          if (response == 0) {
            res.status(401).send("Erro ao executar o PlayBack.");
          } else {
            res.status(401).send("Nenhuma gravação encontrada com as especificações fornecidas.");
          }
        } else {
          res.status(200).send(response);
        }
      }, cres.body, req.params.id, req.params.startTime, req.params.endTime);
    }
    };

    sendFirstAuth(function (cres) {
    if (cres.body != null) {
      console.log("Calling second: ", cres.body);
      sendSecondAuth(cbSecondAuth, cres.body);
    }
    });
}

function sendPlayback(cbSendPlayback, data, id, startTime, endTime) {

  var req = unirest('POST', DahuaHost + '/brms/api/v1.0/SS/Playback/StartPlaybackByTime')
  .strictSSL(false)
    .headers({
        'X-Subject-Token': data.token,
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "clientType": "WINPC_V1",
        "clientMac": "30:9c:23:79:40:08",
        "clientPushId": "",
        "project": "PSDK",
        "method": "SS.Playback.StartPlaybackByTime",
        "data": {
            "optional": "/brms/api/v1.0/SS/Playback/StartPlaybackByTime?token=7a882d516f354ca6a6e4b95d0d0a92f7",
            "recordType": "0",
            "streamType": "0",
            "recordSource": "2",
            "channelId": id + "$1$0$0",
            "endTime": endTime,
            "startTime": startTime,
            "streamId": "",
            "enableRtsps": ""
        }
    }))
    .end(function (res) {

      if (res.body.code != 1000 || typeof res.body.data.token == "undefined") {
        console.log("Erro ao executar o playback: "+res.body.desc);
        cbSendPlayback(0);
      } 
      else {
        getPlaybackUrl(cbSendPlayback, data, id, startTime, endTime, res.body.data.token)
      }
      
    });

}

function getPlaybackUrl(cbSendPlayback, data, id, startTime, endTime, token) {

  var req = unirest('POST', DahuaHost + '/brms/api/v1.0/SS/Record/QueryRecords')
  .strictSSL(false)
    .headers({
        'X-Subject-Token': data.token,
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
      "clientType": "WINPC_V1",
      "clientMac": "30:9c:23:79:40:08",
      "clientPushId": "",
      "project": "PSDK",
      "method": "SS.Record.QueryRecords",
      "data": {
          "cardNo": "",
          "optional": "/brms/api/v1.0/SS/Record/QueryRecords?token=f95d07c84a87407eae5ea083ee5ca42e",
          "endTime": endTime,
          "diskPath": "",
          "startIndex": "",
          "streamType": "0",
          "recordType": "0",
          "recordSource": "3",
          "startTime": startTime,
          "endIndex": "",
          "channelId": id + "$1$0$0"
      }
  }))
    .end(function (res) {

      if (res.body.code != 1000) {
        console.log("Erro ao executar o playback: "+res.body.desc);
        cbSendPlayback(0);
      }

      if (res.body.data.records.length > 0) {
        let rtsp = "rtsp://"+ RstpHost +":9320/playback/center?streamID="+ res.body.data.records[0].streamId +"&beginTime="+ startTime +"&endTime="+ endTime +"?token=" + token;
        console.log("RTSP Playback: "+rtsp);
        cbSendPlayback(rtsp);
      }else {
        cbSendPlayback(1);
      }
      
    });

}

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';
exports.getNewIncidente = (req, res) => {
  console.log("Req Body");
  console.dir(req.body);

  var req = unirest('POST', 'https://172.16.115.92:3000/application/fusion')
  .strictSSL(false)
    .headers({
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "url": req.body.url
    }))
    .end(function (cres) { 
        if (typeof cres.body.error !== 'undefined') {
          console.log(cres.body.error); 
          res.status(500).send("Fail"); 
        } else {
            res.status(200).send("Incidente enviado para o Control com sucesso.");
            console.log(cres.raw_body);
        }
    });
};

function sendGetDevicesStatus(cbGetDevices, data, canAdd) {
  var req = unirest('POST', DahuaHost + '/admin/API/tree/devices')
  .strictSSL(false)
    .headers({
        'X-Subject-Token': data.token,
        'Content-Type': 'application/json'
    })
    .send(JSON.stringify({
        "orgCode": "",
        "deviceCodes": [],
        "categories": []
    }))
    .end(function (res) {
      let data = JSON.parse(res.body).data;
      if (typeof data != 'undefined') {
        cbGetDevices(data);
      } else {
        cbGetDevices(data);
      }
    });

}

exports.getDevicesStatus = (req, res, next) => {
  var cbSecondAuth = function (cres) {
      if (typeof cres.body.error !== 'undefined' || typeof cres.body.token === 'undefined') {
        if (res != null) {
          res.status(401).send('Error ' + cres.body.error);
        } else {
          console.log('Error ' + cres.body.error);
        }
      } else {
        sendGetDevicesStatus(function (data) {
          if (data.devices && data.devices.length > 0) {
            let devicesStatus = {
              total: data.devices.length,
              online: 0,
              offline: 0,
              ptz: 0,
              fixed: 0
            }

            for (var i = 0; i < data.devices.length; i++) {
              if (data.devices[i].status != 1) {
                devicesStatus.offline++;
              } else {
                devicesStatus.online++;
              }
              data.devices[i].units.forEach(unit => {
                unit.channels.forEach(channel => {
                  if(channel.cameraType) {
                    if (channel.cameraType == 2) {
                      devicesStatus.ptz++;
                    } else {
                      devicesStatus.fixed++;
                    }
                  }
                })
              });
            }
            res.status(200).send(devicesStatus);
          } else {
            res.status(500).send('Error: Devices not found');
          }
        },cres.body);
      }
    };

    sendFirstAuth(function (cres) {
      if (typeof cres.body !== 'undefined') {
        if (typeof cres.body.randomKey === 'undefined')
          if (res != null) {
            res.status(401).send('Error ' + cres.body.error);
          } else {
            console.log('Error ' + cres.body.error);
          }
        else {
          console.log("Calling second: ", cres.body);
          sendSecondAuth(cbSecondAuth, cres.body);
        }
      } else {
        console.log("Cres.body undefined");
      }
    });
}
